#TEMPLATE(UP_BrowseHelper,'Browse Helper - Upper Park Solutions'), FAMILY('ABC')
#! ***************************************************************************
#! ***************************************************************************
#! Template based on https://github.com/Rick-UpperPark/UpperParkFree/blob/master/Templates/UP_BrowseHelper.tpw
#! Modifications by Carl Barnes https://github.com/CarlTBarnes
#! Note Carl changed "FieldNo" to "ColumnNo" because Field is usually for Queue not LIST. 
#! Check Rick's Way box to revert to wrong names
#!
#EXTENSION(UP_BrowseColumnEquates2,'Generate Browse Column and Group Number equates'),PROCEDURE,MULTI,REQ(BrowseBox(ABC),AFTER)
  #DISPLAY('Template to generate equates for each column ')
  #DISPLAY('in a ABC browse list control.') 
  #DISPLAY('Equates named: Brw#:ColumnNo:FieldVariable') 
  #DISPLAY('') 
  #DISPLAY('Carl Barnes added GROUP Equates. ')   
  #DISPLAY('Equates named: Brw#:GroupNo:FieldVariable')   
  #DISPLAY('The Variable is the first in the Group')   
  #DISPLAY('')   
  #PROMPT('Use "FieldNo" instead of "ColumnNo" equates (Rick''s way)',CHECK),%UseRicksFieldNo,AT(2) 
  #PROMPT('LIST Groups [] generate "GroupNo" equates',CHECK),%GenGroupEquates,AT(2)
  #DISPLAY('')   
  #DISPLAY('These equates can be used instead of hard-coded ')
  #DISPLAY('numeric constants in code where you need the column number.') 
  #DISPLAY('The equate automatically generates the correct value')
  #DISPLAY('if the order of the columns change or new columns are added.') 
#AT(%DataSection)
#IF (%UseRicksFieldNo=%False)
  #EQUATE(%ColumnNoLabel,':ColumnNo')
#ELSE
  #EQUATE(%ColumnNoLabel,':FieldNo')
#ENDIF
! %ListControl Equates for PROPLIST column numbers - UP_BrowseColumnEquates template
#!  ITEMIZE(1),PRE(%ManagerName:FieldNo)  <-- Carl changed FieldNo to ColumnNo
  ITEMIZE(1),PRE(%ManagerName%ColumnNoLabel)
  #FIX(%Control,%ListControl)
  #FOR(%ControlField)
    #SET(%ValueConstruct,%ControlField)
    #INSERT(%CleanDimensions(ABC))
%[30]ValueConstruct EQUATE()
  #ENDFOR
  End
#! ============== Groups =================
#! Groups start with '['. 
#! In the LIST Format() find the Start of the Next List Field's Format in %ControlFieldFormat
#! If that's a Group there will be a '[' BEFORE the Control's Format
  #IF (%GenGroupEquates=%True)
    #DECLARE(%FormatLIST,STRING)
    #SET(%FormatLIST, EXTRACT(%ControlStatement, 'FORMAT', 1))
    #IF (INSTRING('[',%FormatLIST,1))
      #SET(%FormatLIST, SUB(%FormatLIST, 2, LEN(%FormatLIST)-2))  
      #DECLARE(%GroupConstruct,STRING)
      #DECLARE(%PosFieldFmt, LONG)  
         #!dbg: FormatLIST: %FormatLIST
      #SUSPEND
#?!Group Equates %ListControl{PROPLIST:Group + PROPLIST:xxxx, BRW#:GroupNo:Pre:Field}
      #FIX(%Control,%ListControl)
      #FOR(%ControlField)
        #SET(%PosFieldFmt, INSTRING(%ControlFieldFormat, %FormatLIST, 1, 1))
        #IF (INSTRING('[',SUB(%FormatLIST,1,%PosFieldFmt-1),1))
          #SET(%ValueConstruct,%ControlField)
          #INSERT(%CleanDimensions(ABC))
          #SET(%ValueConstruct,%ManagerName & %ColumnNoLabel &':'& %ControlField)
          #SET(%GroupConstruct,%ManagerName &':GroupNo:'& %ControlField)
%[30]GroupConstruct EQUATE(%ValueConstruct)    
            #!dbg: CtrlPos=%PosFieldFmt Fmt List=%(SUB(%FormatLIST,1,%PosFieldFmt+5))  Ctrl=%ControlFieldFormat
        #ENDIF 
        #! Cutoff the front the FormatLIST just found for Column's format
        #SET(%FormatLIST,SUB(%FormatLIST,%PosFieldFmt + LEN(%ControlFieldFormat),9999) )
            #!dbg: FormatNext=%FormatLIST
      #ENDFOR
      #RESUME
    #ENDIF  
  #ENDIF    
#ENDAT